// CallGateTSDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CallGateTS.h"
#include "CallGateTSDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCallGateTSDlg dialog

CCallGateTSDlg::CCallGateTSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCallGateTSDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCallGateTSDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCallGateTSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCallGateTSDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCallGateTSDlg, CDialog)
	//{{AFX_MSG_MAP(CCallGateTSDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_RING3, OnPlayRing3)
	ON_BN_CLICKED(BTN_CALLGATE, OnCallgate)
	ON_BN_CLICKED(BTN_IOPL, OnIopl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCallGateTSDlg message handlers

BOOL CCallGateTSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCallGateTSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCallGateTSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCallGateTSDlg::OnOK() 
{
	
//	CDialog::OnOK();
}

void CCallGateTSDlg::OnCancel() 
{
	CDialog::OnCancel();
}

//EFlags Register
typedef struct _X86_EFLAGS	//EFLAGS Register
{
	union
	{
		struct
		{
			DWORD dValue;            // packed value
		};
		struct
		{
			unsigned CF       :  1; //Carry Flag
			unsigned Default1 :  1; //1
			unsigned PF       :  1; //Parity Flag
			unsigned Default2 :  1; //0
			unsigned AF       :  1; //Auxiliary Carry Flag
			unsigned Default3 :  1; //0
			unsigned ZF       :  1; //Zero Flag
			unsigned SF		  :  1; //Sign Flag  <<   Status Flag

			unsigned TF       :  1; //Trap Flag
			unsigned IF       :  1; //Interrupt enable Flag
			unsigned DF       :  1; //Direction Flag
			unsigned OF       :  1; //Overflow Flag
			unsigned IOPL     :  2; //I/O Privilege Level
			unsigned NT       :  1; //Nested Task
			unsigned Default4 :  1; //0

			unsigned RF       :  1; //Resume Flag
			unsigned VM		  :  1; //Virtual 8086 Mode
			unsigned AC       :  1; //Alignment Check
			unsigned VIF      :  1; //Virtual Interrupt Flag
			unsigned VIP      :  1; //Virtual Interrupt Pending
			unsigned ID       :  1; //ID Flag
			//unsigned Reserve   : 10;
		};
	};
}X86_EFLAGS, *PX86_EFLAGS;

void SetSpeakerOn()
{
	__asm
	{
		push eax
		in al, 0x61
		or al, 0x03
		out 0x61, al
		pop eax
	}	
}

void SetSpeakerOff()
{
	__asm
	{
		push eax
		in al, 0x61
		and al, ~0x03
		out 0x61, al
		pop eax
	}	
}

void SetFrequency(unsigned int hertz)
{
	unsigned int divisor = 1193180/hertz;
	__asm
	{
		push eax
		mov al, 0xb6
		out 0x43, al
		mov eax, divisor		
		out 0x42, al
		shr eax,8
		out 0x42,al
		pop eax
	}
}

void Sound(unsigned int hertz, int delay)
{
	SetFrequency(hertz);
	SetSpeakerOn();
    
	Sleep(1000);

	SetSpeakerOff();
}

void PlaySound()
{
	Sound(261, 8);
	Sound(293, 8);
	Sound(329, 8);
}

#include "..\sys\Prism.h"
#include "DrvFunc.h"

HANDLE	G_hDrv = NULL;
#define DRIVE_NAME	"CallGate"
WORD	G_TempGDT[8192];

BOOL CreateCallGate(void *FuncAddress, int NumParam, PWORD pSelector)
{
	CALLGATE_INFO callgateInfo;

	if(G_hDrv == NULL) 
	{
		G_hDrv = MakeDrvSimpleStart(NULL, DRIVE_NAME);
		if(G_hDrv == NULL) return FALSE;
	}

	memset(&callgateInfo, 0, sizeof(CALLGATE_INFO));
    callgateInfo.FuncAddress=FuncAddress;
    callgateInfo.NumParam=NumParam;

	MakeDrvIoControl (G_hDrv, IOCTL_CREATE_CALLGATE, &callgateInfo, sizeof(CALLGATE_INFO),
					&callgateInfo, sizeof(CALLGATE_INFO));

	G_TempGDT[callgateInfo.CallGateSelector >> 3] = callgateInfo.CodeSelector;
	*pSelector=callgateInfo.CallGateSelector;

	return TRUE;
}

BOOL ReleaseCallGate(WORD callgataSelector)
{
	CALLGATE_INFO callgateInfo;

	if(G_hDrv == NULL) return FALSE;

	memset(&callgateInfo, 0, sizeof(CALLGATE_INFO));
    callgateInfo.CallGateSelector=callgataSelector;
    callgateInfo.CodeSelector=G_TempGDT[callgataSelector >> 3];

	MakeDrvIoControl (G_hDrv, IOCTL_RELEASE_CALLGATE, &callgateInfo, sizeof(CALLGATE_INFO),
					&callgateInfo, sizeof(CALLGATE_INFO));
 
	return TRUE;
}

static void _declspec(naked) CallGateFunc()
{
    _asm {
		PUSHAD
		PUSHFD
    }
	
	PlaySound();

    _asm {
		POPFD
		POPAD
		//
         retf
    }
}



BOOL CCallGateTSDlg::DestroyWindow() 
{
	if(G_hDrv)
	{
		MakeDrvStop(DRIVE_NAME, G_hDrv);
	}
	return CDialog::DestroyWindow();
}

void CCallGateTSDlg::OnPlayRing3() 
{
	PlaySound();
}

void CCallGateTSDlg::OnCallgate() 
{
	WORD callgateSelector;
	short farcall[3];

	if(CreateCallGate(CallGateFunc, 0, &callgateSelector) == FALSE)
	{
		AfxMessageBox("Error !!!");
		return;
	}

	farcall[2]=callgateSelector;
    _asm {
            call fword ptr [farcall]
    }

	ReleaseCallGate(callgateSelector);		
}


#define LOCAL_SIZE	4
//#define LOCAL_SIZE	__LOCAL_SIZE

static void _declspec(naked) CallGateFunc_IOPL()
{
	PX86_EFLAGS	pEFlags;

    _asm {
		PUSHAD
		PUSHFD
		PUSH	EBP
		MOV		EBP, ESP
		SUB		ESP, LOCAL_SIZE

		LEA EAX, [ESP + 0x4 + LOCAL_SIZE]
		MOV pEFlags, EAX		
    }
	
	pEFlags ->IOPL = 3;

    _asm {
		ADD		ESP, LOCAL_SIZE
		POP		EBP
		POPFD
		POPAD
		//
         retf
    }
}

void CCallGateTSDlg::OnIopl() 
{
	WORD callgateSelector;
	short farcall[3];

	if(CreateCallGate(CallGateFunc_IOPL, 0, &callgateSelector) == FALSE)
	{
		AfxMessageBox("Error !!!");
		return;
	}

	farcall[2]=callgateSelector;
    _asm {
            call fword ptr [farcall]
    }

	PlaySound();

	ReleaseCallGate(callgateSelector);			
}
