//Sound.c
#include "ntddk.h"
#include "Intel80x86.h"
#include "UndocNTAPI.h"

#include "Prism.h"

void Ke386SetIoAccessMap(int, UCHAR *);
void Ke386QueryIoAccessMap(int, UCHAR *);
void Ke386IoSetAccessProcess(PEPROCESS, int);

#define		IOPM_SIZE    0x2000
UCHAR		*G_pCopyIOPM = NULL;

/*----------------------------------------------
IoBitsMap  ޸  ҴѴ.
------------------------------------------------*/
BOOLEAN IOPM_Initialize()
{
    G_pCopyIOPM = MmAllocateNonCachedMemory(IOPM_SIZE);
    if(G_pCopyIOPM == 0) 
    {
    	DbgPrint("MmAllocateNonCachedMemory Failed\n");
    	return FALSE;
    }
    DbgPrint("MmAllocateNonCachedMemory Success : %x\n", G_pCopyIOPM);
    RtlFillMemory(G_pCopyIOPM, IOPM_SIZE, 0xFF);	
	return TRUE;
}

/*----------------------------------------------
IoBitsMap  ޸  Ѵ.
------------------------------------------------*/
BOOLEAN IOPM_UnInitialize()
{
    if(G_pCopyIOPM) 
    	MmFreeNonCachedMemory(G_pCopyIOPM, IOPM_SIZE);
    	
    G_pCopyIOPM = NULL;
	return TRUE;
}

/*----------------------------------------------
츮  IoBitsMap   TSS
IoBitsMap Ͽ ش.
------------------------------------------------*/
BOOLEAN IOPM_SetIOPM(USHORT nIoPort, BOOLEAN bArrow)
{
	struct	_EPROCESS *Process;
	UCHAR	*pIOPM;	
	UCHAR	bDummy;
	
	//
	if(nIoPort > 65536)
		return FALSE;
		
	Ke386QueryIoAccessMap(1, G_pCopyIOPM);
	
	//CopyIOPM Bit Ͽ ش.	
	pIOPM = G_pCopyIOPM;
	pIOPM += (BYTE)(nIoPort / 8);
	if( bArrow )
	{
		bDummy = 0xFF;
		bDummy ^= ( 1 << (nIoPort % 8) );		
		*pIOPM &= bDummy;				
	}	
	else
	{
		*pIOPM |= ( 1 << (nIoPort % 8) );
	}
	
	// CopyIOPM ýۿ ݿѴ.
	Ke386SetIoAccessMap(1, G_pCopyIOPM);	
	//PsLookupProcessByProcessId(ProcessID, &Process);	 
	Process = PsGetCurrentProcess();
	Ke386IoSetAccessProcess(Process, 1);
	return TRUE;
}

/*====================================================================
My_DriverEntry
====================================================================*/
VOID My_DriverEntry(IN PDRIVER_OBJECT DriverObject ,PDEVICE_OBJECT deviceObject)
{
	IOPM_Initialize();
}

/*====================================================================
My_IoControl
====================================================================*/
VOID My_DriverUnload(IN PDRIVER_OBJECT DriverObject)
{
	IOPM_UnInitialize();
}

/*====================================================================
My_IoControl
====================================================================*/
NTSTATUS My_IoControl(PFILE_OBJECT pFileObject, ULONG nIoCode, PCHAR pSystemBuffer, 
					ULONG nInput, ULONG nOutput, ULONG *nReturnOut)
{
	NTSTATUS ntStatus = STATUS_SUCCESS;
		
	switch (nIoCode)
	{
		case IOCTL_CREATE_CHANGE_IOPM:
		{			
		    PIO_PORT 	pIoPort;
			PCHAR		pIOPL;
			
		    pIoPort = (PIO_PORT)pSystemBuffer;
		    IOPM_SetIOPM(pIoPort->nIoPort, pIoPort->bArrow);   
		    
		    break;
		}
	}
	
	return ntStatus;
}
