//PageFault.h

/*********************************************************************************************************************
Interrupt 14 : Page Fault Hook  Ǿ ƾ
 *Page Fault Hook óÿ ݵ NonPaged ޸𸮰 ٷ Ѵ.  ó PageFault ߻ų ̸ ó  Page
  Fault Handler ٽ 츮ʿ ֱ⶧  ߻ϰ ȴ.
 * 츮  ų Լ ϱ  ϴ Stack  Paged ޸𸮰 ɼ  Ƿ
  ̷ƾ Ư NonpagedǾ Ư Stack   ϰ ִ.
*********************************************************************************************************************/
//Using Example.
//
//INT_API IntHandler_PageFault(ULONG nOccurCode, ULONG nAccessMemory, ULONG nErrorCode)
//{
//	ULONG n = 0;
//	
//	n = nOccurCode;
//}
//
//	BEGIN_MAKE_INT_HANDLER()
//		MAKE_INT_HANDLER14_PAGEFAULT(IntHandler_PageFault)
//	END_MAKE_INT_HANDLER()	
//	
//	TestFunc()
//	{
//		HOOK_INTERRUPT14_PAGE_FAULT()
//		UNHOOK_INTERRUPT14_PAGE_FAULT()
//	}
//

#define	 INT_NUM_PAGEFAULT	14
#define	 KERNEL_MODE_FS		0x30

#define PF_ECODE_IS_USER_LEVEL(_ERRCODE) 	((_ERRCODE) & 0x4)	//Access Kernel(0) / User(1) 	(3° Bit)
#define PF_ECODE_IS_WRITE_ACCESS(_ERRCODE) 	((_ERRCODE) & 0x2)	//Access Read(0) / Write(1) 	(2° Bit)
#define PF_ECODE_IS_NOT_PRESENT(_ERRCODE) 	(!((_ERRCODE) & 0x1))	//PƮ 0 (0) / Access(1)	(1° Bit)


#define INT_API	void __stdcall //INT_API IntHandler_Memory(ULONG nIntNum)
#define BEGIN_MAKE_INT_HANDLER()	
#define END_MAKE_INT_HANDLER()	

// =================================================================
// MAKE_INT_HANDLER14_PAGEFAULT(_CALLBACK)
// =================================================================
#define MAKE_INT_HANDLER14_PAGEFAULT(_CALLBACK) \
	static ULONG	GInt14_OldInt14PageFaultHandler = 0; \
	static ULONG 	GInt14_OrgEAX, GInt14_OrgESP; \
	static ULONG	GInt14_OccurCode, GInt14_AccessMemory, GInt14_ErrorCode; \
	static short 	GInt14_OrgDS; \
	\
	static void _declspec(naked) MakeInt14_PageFaultHandler() \
	{	 \
		/* ESP, DS  */ \
		__asm { PUSH ESP } \
		__asm { PUSH EAX } \
		/* Ʈ   */ \
		__asm { MOV EAX, [ESP + 0x4] } \
		__asm { MOV GInt14_ErrorCode, EAX } \
		__asm { MOV EAX, [ESP + 0x8] } \
		__asm { MOV GInt14_OccurCode, EAX } \
		__asm { MOV EAX, cr2 } \
		__asm { MOV GInt14_AccessMemory, EAX } \
		__asm { MOV EAX, GInt14_OrgEAX } \
		/*⺻   */ \
		__asm { PUSHAD } \
		__asm { PUSHFD  }\
		__asm { PUSH FS } \
		__asm { MOV	AX, KERNEL_MODE_FS } \
		__asm { MOV	FS, AX	 } \
		/*ݹԼ ȣ*/ \
		__asm { push GInt14_ErrorCode } \
		__asm { push GInt14_AccessMemory } \
		__asm { push GInt14_OccurCode }	 \
		__asm { call _CALLBACK } \
		/*  */ \
		__asm { POP     FS } \
		__asm { POPFD } \
		__asm { POPAD } \
		/*Original Restore*/ \
		__asm { POP     EAX } \
		__asm { POP     ESP } \
		/* ڵ鷯 ȣ*/ \
		__asm { jmp dword ptr cs:[GInt14_OldInt14PageFaultHandler] } \
	}

// =================================================================
// HOOK_INTERRUPT
// =================================================================
#define HOOK_INTERRUPT14_PAGE_FAULT() \
	{ \
	    X86_GATE  *aIdtEntry;	\
	    char G_szBuffIdtr[6];	\
	    PIDTR G_pIDTR=(PIDTR)G_szBuffIdtr;	\
		\
		/*Original  Ʈ ڵ鷯 */ \
	    __asm { sidt G_szBuffIdtr } \
	    aIdtEntry=(PX86_GATE)G_pIDTR->Base; \
		\
	    GInt14_OldInt14PageFaultHandler=((unsigned int)aIdtEntry[INT_NUM_PAGEFAULT].OffsetHigh<<16U)| (aIdtEntry[INT_NUM_PAGEFAULT].OffsetLow); \
		/*ο  Ʈ ڵ鷯 */ \
	    __asm { cli } \
	    aIdtEntry[INT_NUM_PAGEFAULT].OffsetLow=(unsigned short)MakeInt14_PageFaultHandler; \
	    aIdtEntry[INT_NUM_PAGEFAULT].OffsetHigh=(unsigned short)((unsigned int)MakeInt14_PageFaultHandler>>16); \
	    __asm { sti } \
	}


// =================================================================
// UNHOOK_INTERRUPT
// =================================================================
#define UNHOOK_INTERRUPT14_PAGE_FAULT() \
	{ \
	    X86_GATE  *aIdtEntry; \
	    char G_szBuffIdtr[6];	\
	    PIDTR G_pIDTR=(PIDTR)G_szBuffIdtr;	\
		\
		if(GInt14_OldInt14PageFaultHandler != 0) \
		{ \
		    __asm { sidt G_szBuffIdtr } \
		    \
		    aIdtEntry=(PX86_GATE)G_pIDTR->Base; \
		    \
		    __asm { cli } \
		    aIdtEntry[INT_NUM_PAGEFAULT].OffsetLow=(unsigned short)GInt14_OldInt14PageFaultHandler; \
		    aIdtEntry[INT_NUM_PAGEFAULT].OffsetHigh=(unsigned short)((unsigned int)GInt14_OldInt14PageFaultHandler>>16); \
		    __asm { sti } \
		    GInt14_OldInt14PageFaultHandler = 0; \
		 } \
	}
